// accessories
$(document).ready(function () {
    var app = window.app;
    var $cont = $('#app-accessories');
    //console.log(app.info.model);
    var $models = $('#app-accessories-models');
    var $tpl = $cont.find('#app-accessories-tpl > section');
    var $typeButtons = $cont.find('.update_buttons');

    var $containers = $cont.find('.app-accessories-cont');
    var $messages = $cont.find('#app-accessories-msg');
    var $msgLoading = $messages.find('.js-msg-process');

    var getModels = function () {
        app.api.send({
            url:app.api.getUrl('accessories/models'),
            success:function (data) {
                var options = [];
                options.push('<option value="0">Все</option>');
                if (data.success && data.models) {
                    var models = data.models;
                    for (var i = 0; i < models.length; i++) {
                        var model = models[i];
                        //console.log(app.info.model+' - '+model.model_min);
                        options.push('<option'+((app.info.model == model.model_min) ? ' selected' : '')+' value="' + model.id + '">' + model.model + '</option>');
                    }
                }
                $models.html(options.join(''));

                //Получаем список товаров, после выбора машины
                var type = $typeButtons.find('li.active').attr('data-type');
                fillByType(type, 0);
                $containers.filter('[data-type="' + type + '"]').show();
            }
        });
    };

    var fillByType = function (type, offset) {
        type = type || 1;
        offset = offset || 0;
        var $selectedModel = $models.find(':selected');
        //console.log($selectedModel);
        var modelId = 0;
        if ($selectedModel.length) {
            modelId = $selectedModel.eq(0).val();
        }
        var $container = $containers.filter('[data-type="' + type + '"]');
        if (!($container.attr('data-loading')) && !($container.attr('data-stop')) && offset == $container.find('>section').length) {
            $container.attr('data-loading', 1);
            $container.append($msgLoading.clone());
            app.api.send({
                url:app.api.getUrl('accessories/list', [modelId, type, offset]),
                success:function (data) {
                    $container.find('.js-msg').remove();
                    if (data.success && data.list) {
                        var list = data.list;
                        for (var i = 0; i < list.length; i++) {
                            var detail = list[i];
                            var $section = $tpl.clone();
                            $section.find('.additional_part_photo > img').attr('src', detail.src);
                            $section.find('.additional_part_text').html('<p>' + detail.header + '</p>');
                            $container.append($section);
                        }
                        $container.attr('data-loading', "");
                    } else {
                        $container.attr('data-stop', 1);
                    }
                }
            });
        }
    };


    var refreshStatus = function () {
        getModels();
        /*var type = $typeButtons.find('li.active').attr('data-type');
        fillByType(type, 0);
        $containers.filter('[data-type="' + type + '"]').show();*/
    };


    $typeButtons.find('li').click(function () {
        var $this = $(this);
        if (!$this.hasClass('active')) {
            $typeButtons.find('li').removeClass('active');
            $this.addClass('active');
            $containers.hide();
            var dataType = $this.attr('data-type');
            var $activeContainer = $containers.filter('[data-type="' + dataType + '"]');
            $activeContainer.html('');
            $activeContainer.attr('data-loading', "");
            $activeContainer.attr('data-stop', "");
            fillByType(dataType, 0);
            $activeContainer.show();
        }
        return false;
    });

    $models.change(function(){
        var type = $typeButtons.find('li.active').attr('data-type');
        var $container = $containers.filter('[data-type="' + type + '"]');
        $container.html('');
        $container.attr('data-loading', "");
        $container.attr('data-stop', "");
        fillByType(type, 0);
    });

    $(document).endlessScroll({
        fireOnce: false,
        fireDelay: 500,
        callback: function(p) {
            if($cont.is(':visible'))
            {
                var type = $typeButtons.find('li.active').attr('data-type');
                var $container = $containers.filter('[data-type="' + type + '"]');
                fillByType(type, $container.find('section').length);
            }
        },
        bottomPixels: 150
    });

    $.router(/^\/accessories$/, app.login.decorator(function () {
        app.inner.activate('accessories', {
            heading:'Доп. оборудование',
            refresh:refreshStatus
        });
        if (!$models.html()) {
            refreshStatus();
        }
    }));
});

