// actions
$(document).ready(function(){
    var app = window.app;

    var $appCont = $('#app-actions-one-container');
    var $cont = $appCont.find('> article');
    var $pagination = $appCont.find('.pagination');
    var $prevLink = $pagination.find('.prev a');
    var $nextLink = $pagination.find('.next a');

    $cont.attr('data-one', '');

    var $actionList = $('#app-actions-list');

    var $messages = $appCont.find('#app-actions-one-msg');
    var $msgLoading = $messages.find('.js-msg-process');
    var $msgError = $messages.find('.js-msg-error');
    var $msgServerError = $messages.find('.js-msg-server-error');

    var refreshStatus = function(){
        $cont.html($msgLoading.clone());
        var alias = $cont.attr('data-one');
        var $currentAction = $actionList.find('li[data-alias="' + alias + '"]');
        app.api.send({
            url: app.api.getUrl('actions/item', alias),
            success: function(data) {
                $cont.html('');
                if (data.success && data.text) {
                    if ($currentAction.length) {
                        $nextLink.removeClass('.inactive');
                        var $prevAction = $currentAction.prev();
                        if ($prevAction.length) {
                            $prevLink.removeClass('inactive').attr('href', $prevAction.find('.js-item-date').attr('href'));
                        } else {
                            $prevLink.addClass('inactive').attr('href', 'javascript:;');
                        }
                        var $nextAction = $currentAction.next();
                        if ($nextAction.length) {
                            $nextLink.removeClass('inactive').attr('href', $nextAction.find('.js-item-date').attr('href'));
                        } else {
                            $nextLink.addClass('inactive').attr('href', 'javascript:;');
                        }
                        app.inner.setHeading($currentAction.attr('data-date'));
                        $cont.append('<h2>' + $currentAction.attr('data-heading') + '</h2>');
                    }
                    $cont.append(data.text);
                } else {
                    $cont.html($msgError.clone());
                }
            },
            error: function(xhr) {
                $cont.html($msgServerError.clone());
            }
        });
    };
    $.router(/^\/actions-one\/(.+)$/, app.login.decorator(function (m, one) {
        $cont.attr('data-one', one);
        app.inner.activate('actions-one', {
            heading: '',
            refresh: refreshStatus,
            up: '#/actions'
        });
        refreshStatus();
    }));
});
