// actions
$(document).ready(function () {
    var app = window.app;

    var $cont = $('#app-actions-list');
    var $tpl = $('#app-actions-tpl > li');

    var $appContainer = $('#app-actions-container');
    var $messages = $appContainer.find('#app-actions-msg');
    var $msgLoading = $messages.find('.js-msg-process');
    var $msgNone = $messages.find('.js-msg-none');
    var $msgServerError = $messages.find('.js-msg-server-error');

    var refreshStatus = function () {
        $cont.html('');
        $cont.append($msgLoading.clone());
        app.api.send({
            url:app.api.getUrl('actions/list'),
            success:function (data) {
                $cont.html('');
                if (data.success && data.actions) {
                    for (var i = 0; i < data.actions.length; i++) {
                        var item = data.actions[i];
                        var $action = $tpl.clone();
                        var newsDate = (item.date > '0000-00-00') ? app.format.dateFormat(item.date) : '';
                        $action.attr({
                            'data-date':newsDate,
                            'data-heading':item.heading,
                            'data-alias':item.alias
                        });
                        $action.find('.js-item-date').html('<span class="news_date">' + newsDate + '</span>' + item.heading).attr('href', '#/actions-one/' + item.alias);
                        if (i == (data.actions.length - 1)) {
                            $action.find('.js-bottom-border').show();
                        }
                        $cont.append($action);
                    }
                } else {
                    $cont.html('');
                    $cont.append($msgNone.clone());
                }
            },
            error:function (xhr) {
                $cont.html('');
                $cont.append($msgServerError.clone());
            }
        });
    };
    $.router(/^\/actions$/, app.login.decorator(function () {
        app.inner.activate('actions', {
            heading:'Акции компании',
            refresh:refreshStatus
        });
        if (!$cont.html()) {
            refreshStatus();
        }
    }));
});
