// contact
$(document).ready(function () {
    var app = window.app;
    $.router(/^\/contact\/([\w-]+)$/, function (m, alias) {
        var $container = $('#app-contact-one-all');
        var $contacts = $container.find('section.contact_container');
        var $contact = $contacts.filter('[data-contact="' + alias + '"]');
        if (!$contact.length) {
            $contact = $contacts.eq(0);
            alias = $contact.attr('data-for');
        }

        /* map motion */
        var $map = $contact.find('.contact_map');
        var xMin = $map.data('xMin');
        if (typeof xMin != 'number') {
            var bgImg = $map.css('backgroundImage');
            var mapDisplay = $map.css('display');
            if (mapDisplay == 'block' && bgImg) {
                var matches = bgImg.match(/url\((.*)\)/i);
                bgImg = matches[1] || bgImg;
                $('<img src="' + bgImg + '" />').load(function () {
                    $map.data('xMin', ($map.width() - this.width));
                    $map.data('yMin', ($map.height() - this.height));
                });
            }

            $map.data('bgX', parseFloat($map.css('backgroundPositionX').replace(/[^\-\d\.]/g, '')));
            $map.data('bgY', parseFloat($map.css('backgroundPositionY').replace(/[^\-\d\.]/g, '')));

            var moveMap = function (dx, dy) {
                var bgX = $map.data('bgX') + dx;
                var bgY = $map.data('bgY') + dy;
                if (bgX >= $map.data('xMin') && bgX <= 0) {
                    $map.css('backgroundPositionX', bgX);
                }
                if (bgY >= $map.data('yMin') && bgY <= 0) {
                    $map.css('backgroundPositionY', bgY);
                }
            };

            $map.bind('touchstart mousedown', function (e) {
                var $this = $(this);
                var evt = e.originalEvent;
                var cords;
                if (evt.touches) {
                    cords = {
                        x:evt.touches[0].pageX,
                        y:evt.touches[0].pageY
                    }
                } else {
                    cords = {
                        x:e.pageX,
                        y:e.pageY
                    }
                }
                $this.data('xStart', cords.x);
                $this.data('yStart', cords.y);
                $this.data('bgX', parseFloat($this.css('backgroundPositionX').replace(/[^\-\d\.]/g, '')));
                $this.data('bgY', parseFloat($this.css('backgroundPositionY').replace(/[^\-\d\.]/g, '')));
            });

            $map.bind('touchmove mousemove', function (e) {
                var $this = $(this);
                var xStart = $this.data('xStart');
                var yStart = $this.data('yStart');
                if (typeof xStart == 'number') {
                    var evt = e.originalEvent;
                    var cords;
                    if (evt.touches) {
                        cords = {
                            x:evt.touches[0].pageX,
                            y:evt.touches[0].pageY
                        }
                    } else {
                        cords = {
                            x:e.pageX,
                            y:e.pageY
                        }
                    }
                    var dx = cords.x - xStart;
                    var dy = cords.y - yStart;
                    moveMap(dx, dy);
                }
            });

            $map.bind('touchend mouseup', function (e) {
                var $this = $(this);
                var xStart = $this.data('xStart');
                if (typeof xStart == 'number') {
                    $this.removeData('xStart');
                    $this.removeData('yStart');
                }
            });

            $map.find('.map_link').bind('click', function(e){
                var $link = $(this);
                var dx = 0;
                var dy = 0;
                if ($link.hasClass('top_arrow')) {
                    dx = 0;
                    dy = -10;
                } else if ($link.hasClass('right_arrow')) {
                    dx = 10;
                    dy = 0;
                } else if ($link.hasClass('bottom_arrow')) {
                    dx = 0;
                    dy = 10;
                } else if ($link.hasClass('left_arrow')) {
                    dx = -10;
                    dy = 0;
                }
                moveMap(dx, dy);
                return false;
            });
        }

        var header = $contact.find('.js-heading').html();
        app.inner.activate('contact-one', {
            heading:header,
            up:'#/contact'
        });
        $contacts.hide();
        $contact.show();
    });
});
