window.app = window.app || {};
window.app.productName = 'Автокабинет';
window.app.alertButton = 'Ок';
window.app.confirmButtom = 'Да,Отмена';

$(document).ready(function () {
    var app = window.app;

    // loading page
    app.loader = (function () {
        var $loader = $('#app-loading');
        var $inner = $('#app-loading-msg');
        var showLoader = function (msg) {
            msg = msg || '';
            $inner.html(msg);
            $loader.show();
        };
        var appendValue = function (msg) {
            msg = msg || '';
            var html = $inner.html();
            $inner.html(html + msg);
        };
        var hideLoader = function () {
            $loader.hide();
        };
        var replaceMessage = function (msg) {
            msg = msg || '';
            $inner.html(msg);
        };
        var delayHide = function (func) {
            func = func || function () {
            };
            $loader.show().delay(2000).fadeOut(func);
        };
        return {
            show:showLoader,
            addMsg:appendValue,
            replaceMsg:replaceMessage,
            hide:hideLoader,
            delayHide:delayHide
        };
    })();

    // hide all pages
    app.hidePages = function () {
        $('body > [data-role="page"]').hide();
    };

    app.vin = '';

    app.api = (function () {
        // TODO: create base URL from window location
        var baseUrl = '/toyota-mobile/index.php/';
        //var baseUrl = '/index.php/';
        if (window.location.protocol.match(/file/)) {
            baseUrl = 'http://www.avtocabinet.ru' + baseUrl;
            //baseUrl = 'http://avtocabinet.local' + baseUrl;
        }
        var getUrl = function (url, params) {
            var parts = [baseUrl + url];
            if (params) {
                if (params === true) {
                    parts.push(app.vin);
                } else {
                    parts = parts.concat(params);
                }
            }
            return parts.join('/');
        };
        var send = function (params) {
            if (params.to && !params.url) {
                params.url = getUrl(params.to, true);
            }
            params.dataType = params.dataType || 'json';
            $.ajax(params);
        };
        return {
            getUrl:getUrl,
            send:send
        };
    })();

    var $vin = $('.app-info-vin');
    var $model = $('.app-info-model');
    app.clear = function () {
        app.vin = '';
        app.info = undefined;
        $vin.html('');
        $model.html('');
        $('.js-for-clean').html('');
        if (typeof localStorage != 'undefined') {
            try {
                $.each(['vin', 'model', 'code', 'prevVin'], function(idx, val){
                    localStorage.removeItem(val);
                });
            } catch (e) {};
        }
    };

    app.setInfo = function (vin, info) {
        if ($.inArray(vin, app.prevVin) < 0) {
            app.prevVin.push(vin);
        }
        app.vin = vin;
        $vin.html('VIN: ' + app.vin);
        app.info = info;
        var model = '';
        if (app.info.model) {
            model += 'Модель: ' + app.info.model;
            if (app.info.code) {
                model += ' (' + app.info.code + ')';
            }
        }
        $model.html(model);
        if (typeof localStorage != 'undefined') {
            try {
                localStorage.setItem('vin', vin);
                localStorage.setItem('model', info.model);
                localStorage.setItem('code', info.code);
                localStorage.setItem('prevVin', JSON.stringify(app.prevVin));
            } catch (e) {}
        }
    };
    app.prevVin = [];

    var $header = $('header');

    app.buttons = {
        $refresh:$header.find('.button_refresh')
    };

    app.format = (function () {
        var months = ["января", "февраля", "марта", "апреля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря"];
        var shortMonths = ["янв", "февр", "март", "апр", "мая", "июн", "июл", "авг", "сент", "окт", "нояб", "дек"];
        var dayNames = ["воскресенье", "понедельник", "вторник", "среда", "четверг", "пятница", "суббота"];
        var dateFromMysql = function (datetime) {
            var t = datetime.split(/[- :]/);
            return new Date(t[0], t[1] - 1, t[2], t[3] || 0, t[4] || 0, t[5] || 0);
        };
        var dateFormat = function (date, short) {
            short = short || false;
            if (typeof date == 'string') {
                date = dateFromMysql(date);
            }
            var year = date.getFullYear();
            var month = months[date.getMonth()];
            if (short == 'shortest') {
                month = shortMonths[date.getMonth()];
            }
            var day = date.getDate();
            var result = day + ' ' + month;
            if (short === false || short == 'full') {
                result += ' ' + year;
            }
            if (short == 'full') {
                result += ', ' + dayNames[date.getDay()];
            }
            return result;
        };

        var padInt = function(val, count) {
            count = count || 2;
            var res = "" + val;
            while (res.length < count) {
                res = "0" + res;
            }
            return res;
        };

        var services = {
            'ТЦА':'ТЦ &laquo;Автово&raquo;',
            'ТЦП':'ТЦ &laquo;Приморский&raquo;',
            'ПАРНАС':'ТЦ &laquo;Парнас&raquo;',
            'ЛП':'ТЦ &laquo;Лексус-Приморский&raquo;'
        };
        var serviceCenterFormat = function (sc) {
            var result = sc;
            if (services[sc]) {
                result = services[sc];
            }
            return result;
        };
        return {
            dateFromMysql:dateFromMysql,
            dateFormat:dateFormat,
            serviceCenter:serviceCenterFormat,
            padInt:padInt
        };
    })();
    app.inner = (function () {
        var $inner = $('#app-inner');
        var $nav = $inner.find('.app-inner-menu');
        var $heading = $inner.find('#app-inner-heading');
        var $container = $inner.find('#app-inner-container');
        var $retButton = $inner.find('.button_return');
        var $refreshButton = $inner.find('.button_refresh');

        var activate = function (name, params) {
            params = params || {};

            // set active navigation item and page
            $nav.find('li').removeClass('active');
            $nav.find('li[data-for~="' + name + '"]').addClass('active');
            $container.find('>*').hide();
            $container.find('>*[data-for="' + name + '"]').show();

            // set heading
            $heading.html('');
            if (params.heading) {
                $heading.html(params.heading);
            }

            // set buttons
            if (params.up) {
                $retButton.attr('href', params.up);
            } else {
                $retButton.attr('href', '#/home');
            }
            $refreshButton.unbind('click');
            if (params.refresh) {
                $refreshButton.bind('click', params.refresh);
            }

            app.hidePages();
            $inner.show();
        };
        var setHeading = function (header) {
            header = header || '';
            $heading.html(header);
        };
        return {
            activate:activate,
            setHeading:setHeading
        };
    })();

    $('.js-toggle-info').click(function () {
        $(this).find('p').toggle();
    });

    app.login = {};
    app.login.handler = false;
    app.login.decorator = function(callback) {
        var app = window.app;
        return function() {
            var args = arguments;
            if (app.login.handler) {
                if (app.login.handler()) {
                    return callback.apply(callback, args);
                }
            } else {
                return callback.apply(callback, args);
            }
        };
    };
    app.login.isAuthorized = function() {
        if (app.vin) {
            return true;
        } else {
            return false;
        }
    };
    app.login.logout = function() {
        app.vin = '';
        app.clear();
    };
    app.login.lastEnter = false;

    // bootstrap
    if (typeof localStorage != 'undefined') {
        try {
            var vin = localStorage.getItem('vin');
            var model = localStorage.getItem('model');
            var code = localStorage.getItem('code');
            var prevVin = localStorage.getItem('prevVin');
            if (vin) {
                app.setInfo(vin, {model:model, code:code});
            }
            if (prevVin) {
                app.prevVin = JSON.parse(prevVin);
            }
        } catch (e) {}
    }
});
