// history
$(document).ready(function(){
    var app = window.app;

    var $appCont = $('#app-history-order-appCont');

    var $cont = $('#app-history-order-container');
    var $orderTpl = $('#app-history-order-tpl > div');
    var $tableTpl = $('#app-history-order-table-tpl > section');
    var $listTpl = $('#app-history-order-list-tpl > section');

    var $messages = $appCont.find('#app-history-order-msg');
    var $msgLoading = $messages.find('.js-msg-process');
    var $msgError = $messages.find('.js-msg-error');
    var $msgServerError = $messages.find('.js-msg-server-error');

    $cont.attr('data-order', '');

    var refreshStatus = function(){
        $cont.html('');
        $cont.append($msgLoading.clone());
        var orderNumber = $cont.attr('data-order');
        app.api.send({
            url: app.api.getUrl('repairHistory/details', [app.vin, orderNumber]),
            success: function(data) {
                $cont.html('');
                if (data.success && data.order && data.repair) {

                    // fill order
                    var order = data.order;
                    var $order = $orderTpl.clone();
                    var $orderDetails = $order.find('.order_details');
                    if (order.date_end > '0000-00-00') {
                        $orderDetails.append('<dt>Дата</dt><dd>' + app.format.dateFormat(order.date_end) + '</dd>');
                    }
                    if (order.at_code) {
                        $orderDetails.append('<dt>Тип</dt><dd>' + order.at_code + '</dd>');
                    }
                    if (order.sto) {
                        $orderDetails.append('<dt>СТО</dt><dd>' + app.format.serviceCenter(order.sto) + '</dd>');
                    }
                    if (order.master) {
                        $orderDetails.append('<dt>Мастер</dt><dd>' + order.master + '</dd>');
                    }
                    if (order.distance && order.distance > 0) {
                        $orderDetails.append('<dt>Пробег</dt><dd>' + order.distance + ' км</dd>');
                    }
                    $cont.append($order);

                    // fill order sections
                    for (var sectionName in data.repair) {
                        var details = data.repair[sectionName];
                        var $details;
                        if (details[0].unit && !(details[0].unit == 'н/ч' || details[0].unit == 'н.час')) {
                            $details = $tableTpl.clone();
                            var $table = $details.find('> table');
                            for (var i=0; i<details.length; i++) {
                                var part = details[i];
                                $table.append('<tr>'+
                                    '<td>' + part.name + '<br><span>' + part.code + '</span></td>'+
                                    '<td>' + part.so + ' ' + part.unit + '</td>'+
                                    '</tr>');
                            }
                        } else {
                            $details = $listTpl.clone();
                            var $list = $details.find('> ul');
                            for (var i=0; i<details.length; i++) {
                                var part = details[i];
                                $list.append('<li>' + part.name + '</li>');
                            }
                        }
                        var displaySectionName = sectionName;
                        if (displaySectionName == 'Работа') {
                            displaySectionName = 'Работы';
                        }
                        $details.find('> h2').html(displaySectionName);
                        $cont.append($details);
                    }

                } else {
                    $cont.html('');
                    $cont.append($msgError.clone());
                }
            },
            error: function(xhr) {
                $cont.html('');
                $cont.append($msgServerError.clone());
            }
        });
    };
    $.router(/^\/history-order\/(\d+)$/, app.login.decorator(function (m, order) {
        $cont.attr('data-order', order);
        app.inner.activate('history-order', {
            heading: 'Заказ-наряд №' + order,
            refresh: refreshStatus,
            up: '#/history'
        });
        refreshStatus();
    }));
});
