// history
$(document).ready(function(){
    var app = window.app;

    var $cont = $('#app-history-list');
    var $tpl = $('#app-history-tpl > li');

    var $appCont = $('#app-history-appCont');
    var $messages = $appCont.children('#app-history-msg');
    var $msgLoading = $messages.children('.js-msg-process');
    var $msgError = $messages.children('.js-msg-error');
    var $msgServerError = $messages.children('.js-msg-server-error');


    var refreshStatus = function(){
        $cont.html('');
        $cont.append($msgLoading.clone());
        app.api.send({
            to: 'repairHistory/list',
            success: function(data) {
                var buffer = $('<ul>');
                if (data.success && data.history) {
                    for (var i=0; i<data.history.length; i++) {
                        var order = data.history[i];
                        var $order = $tpl.clone();
                        var newsDate = '№ ' + order.account_code + ' ' + app.format.dateFormat(order.date_end);
                        var type = order.at_code + ', ' + app.format.serviceCenter(order.sto);
                        $order.children('.js-item-date')
                          .html('<span class="news_date">' + newsDate + '</span>' + type)
                          .attr('href', '#/history-order/' + order.account_code);
                        if (i == (data.history.length-1)) {
                            $order.children('.js-bottom-border').show();
                        }
                        buffer.append($order);
                    }
                    $cont.html(buffer.html());
                } else {
                    $cont.html($msgError.clone());
                }
            },
            error: function(xhr) {
                $cont.html($msgServerError.clone());
            }
        });
    };
    $.router(/^\/history$/, app.login.decorator(function () {
        app.inner.activate('history', {
            heading: 'История обслуживания',
            refresh: refreshStatus
        });
        if (!$cont.html()) {
            refreshStatus();
        }
    }));
});
