// home
$(document).ready(function () {
    var app = window.app;
    var $home = $('#app-home');
    var $date = $home.find('#app-home-date');
    var $warrantyPeriod = $home.find('.warranty_period');
    var $warrantyCounter = $home.find('.warranty_counter > p');
    var $warrantyImg = $home.find('.warranty_counter > img');
    var showHomePage = function () {

        // set date
        var now = new Date;
        var nowString = app.format.dateFormat(now, true);
        $date.html(nowString);

        var oneDay = 1000*60*60*24;

        // set warranty date
        var setWarranty = function(){
            $warrantyPeriod.html('Обновление информации о сроке гарантии&hellip;');
            $warrantyCounter.html('');
            $warrantyImg.show();
            app.api.send({
                to: 'site/warranty',
                success: function(data) {
                    var periodMsg = '';
                    var counterMsg = '';
                    if (data.success && data.date_sell) {
                        var wr = app.format.dateFromMysql(data.date_sell);
                        wr = new Date(wr.getTime() + (3 * 365 * 24 * 60 * 60 * 1000));
                        var diff = Math.ceil((wr.getTime() - now.getTime())/oneDay);
                        if (diff == 0) {
                            periodMsg = 'Гарантийный срок вашего автомобиля истекает сегодня';
                        } else {
                            var warrDate = app.format.dateFormat(wr) + " года";
                            if (diff > 0) {
                                periodMsg = 'Гарантийный срок вашего автомобиля истекает ' + warrDate;
                                counterMsg = 'Осталось ' + diff + ' дней';
                            } else {
                                periodMsg = ' &nbsp; ';
                                counterMsg = ' &nbsp; ';
                                $warrantyImg.hide();
                            }
                        }
                    } else {
                        periodMsg = ' &nbsp; ';
                        counterMsg = ' &nbsp; ';
                        $warrantyImg.hide();
                    }
                    $warrantyPeriod.html(periodMsg);
                    $warrantyCounter.html(counterMsg);
                }
            })
        };
        if (!$warrantyPeriod.html()) {
            setWarranty();
        }
        app.buttons.$refresh.unbind('click');
        app.buttons.$refresh.bind('click', function(){
            setWarranty();
            return false;
        });
        app.hidePages();
        $home.show();
    };
    $.router(/^\/home/, app.login.decorator(showHomePage));
});
