// login
$(document).ready(function () {
    var app = window.app;
    var api = app.api;
    var $login = $('#app-login');
    app.hidePages();
    $login.show();
    var $submit = $login.find('#app-login-submit');
    var $vin = $login.find('[name="login-vin"]');

    $vin.autocomplete({
        source: app.prevVin
    });

    app.login.handler = function() {
        if (app.login.isAuthorized()) {
            return true;
        }
        navigator.notification.confirm('Необходима авторизация. Перейти на страницу входа?',function(button){
            if(button == 1){
                app.login.lastEnter = true;
                window.location.hash = '#/login';
            } else {
                window.history.go(-1);
            }
        },app.productName,app.confirmButtom);
        /*if (confirm('Необходима авторизация. Перейти на страницу входа?')) {
            app.login.lastEnter = true;
            window.location.hash = '#/login';
        } else {
            window.history.go(-1);
        }*/
        window.history.go(-1);
        return false;
    };

    $submit.click(function () {
        var load = app.loader;
        var vin = $vin.val().replace(/\W/, '').toUpperCase();
        if (!vin) {
			navigator.notification.alert("Введите VIN", function(){}, app.productName, app.alertButton);
            //alert('Введите VIN');
            return false;
        }
        $vin.val(vin);
        load.show("Проверка VIN&hellip;<br>");
        api.send({
            url: app.api.getUrl('site/checkVin', [vin]),
            success:function (data, textStatus, xhr) {
                if (data.success) {
                    var info = {
                        model:data.model,
                        code:data.code
                    };
                    app.setInfo(vin, info);
                    load.replaceMsg("Соединение прошло успешно.<br>Выполняется загрузка Личного кабинета&hellip;");
                    load.delayHide(function () {
                        if (app.login.lastEnter) {
                            window.history.go(-1);
                        } else {
                            window.location.hash = '#/home';
                        }
                    });
                } else {
                    load.replaceMsg("Неверный VIN<br>");
                    load.delayHide();
                }
            },
            error:function (xhr) {
                load.replaceMsg('Ошибка соединения.<br>Попробуйте позже.');
                load.delayHide();
            }
        });
    });

    // assign #/login
    $('.js-logout').click(function(){
        navigator.notification.confirm('Вы действительно хотите выйти?',function(button){
            if(button == 1){
                app.login.logout();
                window.location.hash = '#/login';
            }
        },app.productName,app.confirmButtom);
        /*if (confirm("Вы действительно хотите выйти?")) {
            app.login.logout();
            window.location.hash = '#/login';
        }*/
        return false;
    });
    $.router(/^\/login/, function () {
        if (app.login.isAuthorized()) {
            window.location.hash = '#/home';
        } else {
            app.clear();
            $vin.val('');
            app.hidePages();
            $login.show();
            $vin.autocomplete("option", "source", app.prevVin);
        }
    });

    if (!window.location.hash) {
        window.location.hash = '#/login';
    }
});
