// repair
$(document).ready(function () {
    var app = window.app;
    var $form = $('#app-repair-form');
    var $date = $form.find('#app-repair-date');
    var $dateControls = {
        plus:$date.find('.increase'),
        minus:$date.find('.decrease'),
        input:$date.find('#app-repair-date-text'),
        hidden:$date.find('#app-repair-date-hidden')
    };
    var $time = $form.find('#app-repair-time');
    var $timeControls = {
        plus:$time.find('.increase'),
        minus:$time.find('.decrease'),
        input:$time.find('input')
    };


    var oneDay = 24 * 60 * 60 * 1000;
    var firstDay = new Date((new Date()).getTime() + 2 * oneDay);
    firstDay.setHours(0);
    firstDay.setMinutes(0);
    firstDay.setSeconds(0);
    firstDay.setMilliseconds(0);
    var lastDay = new Date(firstDay.getTime() + 13 * oneDay);

    var setCurrentDate = function (date) {
        var $input = $dateControls.input;
        if (typeof date == 'string') {
            date = app.format.dateFromMysql(date);
        }
        $input.attr('data-year', date.getFullYear());
        $input.attr('data-month', (date.getMonth() + 1));
        $input.attr('data-day', date.getDate());
        $input.val(app.format.dateFormat(date, 'shortest'));
        $dateControls.hidden.val(app.format.dateFormat(date, 'full'));
    };
    var getCurrentDate = function () {
        var $input = $dateControls.input;

        return new Date(parseInt($input.attr('data-year'), 10), (parseInt($input.attr('data-month'), 10) - 1), parseInt($input.attr('data-day'), 10));
    };
    $dateControls.plus.click(function () {
        var newDate = new Date(getCurrentDate().getTime() + oneDay);
        if (newDate.getTime() <= lastDay.getTime()) {
            setCurrentDate(newDate);
        }
    });
    $dateControls.minus.click(function () {
        var newDate = new Date(getCurrentDate().getTime() - oneDay);
        if (newDate.getTime() >= firstDay.getTime()) {
            setCurrentDate(newDate);
        }
    });
    var restoreDate = function () {
        var $input = $dateControls.input;
        if (!$input.attr('data-year')) {
            setCurrentDate(firstDay);
        }
    };

    var fistTime = '08:00';
    var lastTime = '19:00';
    var changeTime = function(diff) {
        var current = $timeControls.input.val().split(':');
        var h = parseInt(current[0], 10);
        var m = parseInt(current[1], 10);
        var operand = diff.substr(0, 1);
        var add = diff.substr(1).split(':');
        var hDiff = parseInt(add[0], 10);
        var mDiff = parseInt(add[1], 10);
        if (operand == '-') {
            m -= mDiff;
            h -= hDiff;
        } else {
            m += mDiff;
            h += hDiff;
        }
        if (m >= 60) {
            m -= 60;
            h += 1;
        } else if (m < 0) {
            m += 60;
            h -= 1;
        }
        var newTime = app.format.padInt(h, 2) + ':' + app.format.padInt(m, 2);
        if (newTime >= fistTime && newTime <= lastTime) {
            $timeControls.input.val(newTime);
        }
    };
    $timeControls.plus.click(function(){changeTime('+00:15');});
    $timeControls.minus.click(function(){changeTime('-00:15');});
    var restoreTime = function() {
        var current = $timeControls.input.val();
        if (!current) {
            $timeControls.input.val(fistTime);
        }
    };

    $form.attr('action', app.api.getUrl('repair/submit'));
    $form.ajaxForm({
        dataType:'json',
        success: function(data) {
            if (data.success) {
                navigator.notification.alert("Заявка успешно отправлена", function(){}, app.productName, app.alertButton);
                //alert('Заявка успешно отправлена');
            } else if (data.errors) {
                var msg = data.errors.join(' ');
                navigator.notification.alert(msg, function(){}, app.productName, app.alertButton);
                //alert(msg);
            }
        }
    });

    var refreshStatus = function () {
        restoreDate();
        restoreTime();
        $form.find('#app-repair-vin').val(app.vin);
        $form.find('#app-repair-model').val(app.info.model);
        $form.find('#app-repair-code').val(app.info.code);
    };

    $.router(/^\/repair$/, app.login.decorator(function () {
        app.inner.activate('repair', {
            heading:'Записаться на ремонт'
        });
        refreshStatus();
    }));
});
