// status
$(document).ready(function(){
    var app = window.app;

    var $cont = $('#app-status-orders');
    var $tpl = $('#app-status-order-tpl > div.order_container');

    var $appCont = $('#app-status-appCont');
    var $messages = $appCont.find('#app-status-msg');
    var $msgLoading = $messages.find('.js-msg-process');
    var $msgNone = $messages.find('.js-msg-none');
    var $msgServerError = $messages.find('.js-msg-server-error');


    var refreshStatus = function(){
        $cont.html('');
        $cont.append($msgLoading.clone());
        app.api.send({
            to: 'status/orders',
            success: function(data) {
                $cont.html('');
                if (data.success && data.orders) {
                    for (var i=0; i<data.orders.length; i++) {
                        var order = data.orders[i];
                        var $order = $tpl.clone();
                        $order.find('.js-order-code').html(order.account_code);
                        if (order.date_finish > '0000-00-00') {
                            $order.find('.js-order-date').html(app.format.dateFormat(order.date_finish));
                        } else {
                            $order.find('.js-order-date').html('Не указана');
                        }
                        if (order.account_state == 2) {
                            $order.addClass('order_done');
                            $order.find('.js-order-status').html('Готов');
                        } else if (order.account_state == 1) {
                            $order.find('.js-order-status').html('В работе');
                        } else {
                            $order.find('.js-order-status').html('Ожидание ремонта');
                        }
                        var $master = $order.find('.order_master');
                        if (order.master) {
                            $master.show();
                            $master.find('.js-order-master').text(order.master.name);
                            $master.find('.js-order-phone').text(order.master.phone);
                        } else {
                            $master.hide();
                        }
                        $cont.append($order);
                    }
                } else {
                    $cont.html('');
                    $cont.append($msgNone.clone());
                }
            },
            error: function(xhr) {
                $cont.html('');
                $cont.append($msgServerError.clone());
            }
        });
    };
    $.router(/^\/status/, app.login.decorator(function () {
        app.inner.activate('status', {
            heading: 'Статус ремонта',
            refresh: refreshStatus
        });
        if (!$cont.html()) {
            refreshStatus();
        }
    }));
});
